看到题目的标签有双指针,因为之前做过leetcode11,所以自然而然带入了那道题的想法。我最初的想法是:先排序(联想到了王道书上的一道题,也是先排序),然后最小的和最大的指针不动,移动在这两个数大小之间的数的指针,这种情况可能找到符合条件的三个数,也可能找不到,然后再移动左右边界的指针。感觉哪里怪怪的。
于是看了官方题解,之后的想法:第一个指针不动(一个for循环遍历所有数),第二个指针不动(一个for循环),第三个指针从后往前找符合条件的三个数,结果超时,其实这个想法并没有用到双指针的思想。
/**
1. Return an array of arrays of size *returnSize.
2. The sizes of the arrays are returned as *returnColumnSizes array.
3. Note: Both returned array and *columnSizes array must be malloced, assume caller calls free().
*/
int comp(const void* a, const void* b)//用来做比较的函数。
{
return *(int*)a - *(int*)b;
}
int** threeSum(int* nums, int numsSize, int* returnSize, int** returnColumnSizes)
{
qsort(nums, numsSize, sizeof(int), comp);
int second = 0;
int** t = NULL;
t = (int**)malloc(sizeof(int*) * (numsSize + 1) * 6);
*returnSize=0;
if (numsSize<3)
return t;
int s1 = 0;
int s2 = 0;
int a = nums[0];
for (int i = 0; i < numsSize - 2; i++)
{
if (nums[i]+nums[i+1]+nums[i+2]>0)
break;
if (nums[i]==a&&i!=0)
continue;
int b = nums[i+1];
for (second = i + 1; second < numsSize; second++)
{
//if (nums[second] == nums[i])
// continue;
if (nums[second]==b&&second!=i+1)
continue;
int c = nums[numsSize-1];
for (int j = numsSize - 1; j > second; j--)
{
//if (nums[j] == nums[second])
// continue;
if (nums[j]==c&&j!=numsSize-1)
continue;
if (nums[i] + nums[second] + nums[j] == 0)
{
s2 = 3;
t[s1] = (int*)malloc(sizeof(int) * 3);
t[s1][0] = nums[i];
t[s1][1] = nums[second];
t[s1++][2] = nums[j];
break;
}
c = nums[j];
}
b=nums[second];
}
a = nums[i];
}
*returnSize = s1;
*returnColumnSizes = (int*)malloc(s1 * sizeof(int));
if (s1!=0)
{
for (int i=0;i<s1;i++)
returnColumnSizes[0][i] =3;
}
return t;
free(t);
}
最后看了别人的代码C语言的双指针法,顿悟之后,用上了双指针:第一个数用for循环,之后两个数一个在第一个数之后,一个在最末尾,判断后两个数之和
大于0:最后一个指针前移
小于0:第二个指针后移
等于0:结果保存之后,同时移动
另:leetcode涉及到二维数组是真的坑
/**
* Return an array of arrays of size *returnSize.
* The sizes of the arrays are returned as *returnColumnSizes array.
* Note: Both returned array and *columnSizes array must be malloced, assume caller calls free().
*/
int comp(const